// ignore_for_file: avoid_print, use_build_context_synchronously

import 'dart:async';
import 'dart:convert';

import 'package:app_telegram_template/app_telegram_template_data/app_telegram_template_data_core.dart';
import 'package:app_telegram_template/page/home/new_channel.dart';
import 'package:app_telegram_template/page/home/new_group.dart';
import 'package:app_telegram_template/page/home/new_super_group.dart';
import 'package:app_telegram_template/page/settings.dart';
import 'package:app_telegram_template/page/sign.dart';
import 'package:app_telegram_template/widget/app_telegram_template.dart';
import 'package:flutter/material.dart';
import 'package:general_lib_flutter/general_lib_flutter.dart';
import 'package:telegram_client/telegram_client.dart';
import "package:general_lib/general_lib.dart" as glx_lib;

class HomePage extends StatefulWidget {
  // final Tdlib tdlib;
  final AppTelegramTemplateData appTelegramTemplateData;
  const HomePage({
    super.key,
    required this.appTelegramTemplateData,
  });

  @override
  State<HomePage> createState() => _HomePageState();
}

class _HomePageState extends State<HomePage> {
  late glx_lib.Listener listener;
  bool is_init_listener = false;

  bool is_in_main_screen = true;

  final GlobalKey bottomBarKey = GlobalKey();

  final GlobalKey globalKey = GlobalKey();

  PageController pageController = PageController();

  Size getRedBoxSize(BuildContext context) {
    final box = context.findRenderObject() as RenderBox;
    return box.size;
  }

  @override
  void initState() {
    // TODO: implement initState
    super.initState();

    WidgetsBinding.instance.addPostFrameCallback((_) {
      setState(() {
        // redboxSize = getRedBoxSize(globalKey.currentContext!);
      });
    });
    onInit();
  }

  FutureOr<dynamic> onUpdate(UpdateTelegramClient updateTelegramClient) async {
    if (is_in_main_screen == false) {
      return null;
    }
    updateTelegramClient.rawData.printPretty();
    return null;
  }

  Future<void> onInit() async {
    print("init");
    listener = widget.appTelegramTemplateData.telegramClient.on(
      event_name: widget.appTelegramTemplateData.telegramClient.event_update,
      onUpdate: onUpdate,
      onError: (error, stackTrace) {},
    );
    setState(() {
      is_init_listener = true;
    });
  }

  final scaffoldKey = GlobalKey<ScaffoldState>();

  @override
  void dispose() {
    if (is_init_listener) {
      listener.cancel();
    }
    super.dispose();
  }

  @override
  Widget build(BuildContext context) {
    return Scaffold(
      key: scaffoldKey,
      // appBar: AppBar(
      //   backgroundColor: context.theme.dialogBackgroundColor,
      //   leading: MaterialButton(
      //     minWidth: 0,
      //     onPressed: () async {
      //       if (scaffoldKey.currentState!.isDrawerOpen) {
      //         // scaffoldKey.currentState!
      //         scaffoldKey.currentState!.closeDrawer();
      //       } else {
      //         scaffoldKey.currentState!.openDrawer();
      //       }
      //     },
      //     child: const Icon(Icons.menu),
      //   ),
      //   title: Text("Telegram Client"),
      //   actions: [
      //     MaterialButton(
      //       minWidth: 0,
      //       onPressed: () async {
      //         setState(() {
      //           is_in_main_screen = false;
      //         });
      //         await searchChats(context: context);
      //       },
      //       child: const Icon(Icons.search),
      //     ),
      //   ],
      // ),

      extendBodyBehindAppBar: true,
      extendBody: true,
      appBar: () {
        return PreferredSize(
          preferredSize: Size(
            context.width,
            450,
          ), // here the desired height
          child: Container(
            key: globalKey,
            decoration: BoxDecoration(
              color: context.theme.dialogBackgroundColor.withOpacity(0.85),
              boxShadow: [
                BoxShadow(
                  color: context.theme.shadowColor.withAlpha(110),
                  spreadRadius: 1,
                  blurRadius: 7,
                  offset: const Offset(0, 3), // changes position of shadow
                ),
              ],
            ),
            child: Column(
              mainAxisSize: MainAxisSize.min,
              crossAxisAlignment: CrossAxisAlignment.start,
              children: [
                SizedBox(
                  height: context.mediaQueryData.padding.top,
                ),
                MaterialButton(
                  shape: RoundedRectangleBorder(
                    borderRadius: BorderRadius.circular(25.0),
                  ),
                  hoverColor: Colors.transparent,
                  splashColor: Colors.transparent,
                  highlightColor: Colors.transparent,
                  onPressed: () async {},
                  padding: const EdgeInsets.all(5),
                  child: Row(
                    mainAxisSize: MainAxisSize.max,
                    mainAxisAlignment: MainAxisAlignment.spaceBetween,
                    children: [
                      Padding(
                        padding: const EdgeInsets.symmetric(vertical: 5),
                        child: MaterialButton(
                          minWidth: 0,
                          onPressed: () async {
                            if (scaffoldKey.currentState!.isDrawerOpen) {
                              // scaffoldKey.currentState!
                              scaffoldKey.currentState!.closeDrawer();
                            } else {
                              scaffoldKey.currentState!.openDrawer();
                            }
                          },
                          child: const Icon(Icons.menu),
                        ),
                      ),
                      const Padding(
                        padding: EdgeInsets.all(5),
                        child: Text(
                          "Telegram",
                          style: TextStyle(
                            fontSize: 16,
                            fontWeight: FontWeight.w600,
                          ),
                        ),
                      ),
                      Padding(
                        padding: const EdgeInsets.symmetric(vertical: 5),
                        child: MaterialButton(
                          minWidth: 0,
                          onPressed: () async {
                            setState(() {
                              is_in_main_screen = false;
                            });
                            await searchChats(context: context);
                          },
                          child: const Icon(Icons.search),
                        ),
                      ),
                    ],
                  ),
                ),
              ],
            ),
          ),
        );
      }(),
      drawer: Drawer(
        width: context.width / 2,
        child: ListView(
          children: [
            ExpansionTile(
              title: Text(
                'New Channel',
                style: TextStyle(
                  color: context.theme.indicatorColor,
                ),
              ),
              children: [
                ListTile(
                  onTap: () {},
                  leading: FlutterLogo(),
                  title: Text(
                    'Azriel',
                    style: TextStyle(
                      color: context.theme.indicatorColor,
                    ),
                  ),
                ),
                ListTile(
                  onTap: () {},
                  leading: FlutterLogo(),
                  title: Text(
                    'Azriel',
                    style: TextStyle(
                      color: context.theme.indicatorColor,
                    ),
                  ),
                ),
                ListTile(
                  onTap: () {},
                  leading: FlutterLogo(),
                  title: Text(
                    'Azriel',
                    style: TextStyle(
                      color: context.theme.indicatorColor,
                    ),
                  ),
                ),
                ListTile(
                  onTap: () {},
                  leading: FlutterLogo(),
                  title: Text(
                    'Azriel',
                    style: TextStyle(
                      color: context.theme.indicatorColor,
                    ),
                  ),
                ),
                ListTile(
                  onTap: () {},
                  leading: FlutterLogo(),
                  title: Text(
                    'Azriel',
                    style: TextStyle(
                      color: context.theme.indicatorColor,
                    ),
                  ),
                ),
                ListTile(
                  onTap: () {},
                  leading: FlutterLogo(),
                  title: Text(
                    'Azriel',
                    style: TextStyle(
                      color: context.theme.indicatorColor,
                    ),
                  ),
                ),
                ListTile(
                  onTap: () {},
                  leading: FlutterLogo(),
                  title: Text(
                    'Azriel',
                    style: TextStyle(
                      color: context.theme.indicatorColor,
                    ),
                  ),
                ),
                ListTile(
                  onTap: () {},
                  leading: FlutterLogo(),
                  title: Text(
                    'Azriel',
                    style: TextStyle(
                      color: context.theme.indicatorColor,
                    ),
                  ),
                ),
              ],
            ),
            ListTile(
              onTap: () async {
                await context.navigator().push(
                  MaterialPageRoute(
                    builder: (context) {
                      return SignPage(
                        appTelegramTemplateData: widget.appTelegramTemplateData,
                      );
                    },
                  ),
                );
              },
              leading: const Icon(
                Icons.add,
              ),
              title: Text(
                'Add Account',
                style: TextStyle(
                  color: context.theme.indicatorColor,
                ),
              ),
            ),
            Divider(
              height: 0,
            ),
            ListTile(
              onTap: () async {
                await context.navigator().push(PageRouteBuilder(
                  pageBuilder: (context, animation, secondaryAnimation) {
                    HomeNewGroupPageAppTelegramTemplate
                        homeNewGroupPageAppTelegramTemplate =
                        HomeNewGroupPageAppTelegramTemplate(
                      appTelegramTemplateData: widget.appTelegramTemplateData,
                    );
                    return homeNewGroupPageAppTelegramTemplate;
                  },
                ));
              },
              leading: const Icon(
                Icons.people,
              ),
              title: Text(
                'New Group',
                style: TextStyle(
                  color: context.theme.indicatorColor,
                ),
              ),
            ),
            ListTile(
              onTap: () async {
                await context.navigator().push(PageRouteBuilder(
                  pageBuilder: (context, animation, secondaryAnimation) {
                    HomeNewSuperGroupPageAppTelegramTemplate
                        homeNewGroupPageAppTelegramTemplate =
                        HomeNewSuperGroupPageAppTelegramTemplate(
                      appTelegramTemplateData: widget.appTelegramTemplateData,
                    );
                    return homeNewGroupPageAppTelegramTemplate;
                  },
                ));
              },
              leading: const Icon(
                Icons.people,
              ),
              title: Text(
                'New Supergroup',
                style: TextStyle(
                  color: context.theme.indicatorColor,
                ),
              ),
            ),
            ListTile(
              onTap: () async {
                await context.navigator().push(PageRouteBuilder(
                  pageBuilder: (context, animation, secondaryAnimation) {
                    HomeNewChannelPageAppTelegramTemplate
                        homeNewGroupPageAppTelegramTemplate =
                        HomeNewChannelPageAppTelegramTemplate(
                      appTelegramTemplateData: widget.appTelegramTemplateData,
                    );
                    return homeNewGroupPageAppTelegramTemplate;
                  },
                ));
              },
              leading: const Icon(
                Icons.speaker,
              ),
              title: Text(
                'New Channel',
                style: TextStyle(
                  color: context.theme.indicatorColor,
                ),
              ),
            ),
            ListTile(
              onTap: () {},
              leading: const Icon(
                Icons.people,
              ),
              title: Text(
                'New Stories',
                style: TextStyle(
                  color: context.theme.indicatorColor,
                ),
              ),
            ),
            ListTile(
              onTap: () {},
              leading: const Icon(
                Icons.people,
              ),
              title: Text(
                'My Stories',
                style: TextStyle(
                  color: context.theme.indicatorColor,
                ),
              ),
            ),
            ListTile(
              onTap: () async {},
              leading: const Icon(
                Icons.contact_phone,
              ),
              title: Text(
                'Contacts',
                style: TextStyle(
                  color: context.theme.indicatorColor,
                ),
              ),
            ),
            ListTile(
              onTap: () async {},
              leading: const Icon(
                Icons.contact_phone,
              ),
              title: Text(
                'Kontak',
                style: TextStyle(
                  color: context.theme.indicatorColor,
                ),
              ),
            ),
            ListTile(
              onTap: () async {},
              leading: const Icon(
                Icons.call,
              ),
              title: Text(
                'Panggilan',
                style: TextStyle(
                  color: context.theme.indicatorColor,
                ),
              ),
            ),
            ListTile(
              onTap: () async {},
              leading: const Icon(
                Icons.people,
              ),
              title: Text(
                'Pengguna Sekitar',
                style: TextStyle(
                  color: context.theme.indicatorColor,
                ),
              ),
            ),
            ListTile(
              onTap: () async {},
              leading: const Icon(
                Icons.message,
              ),
              title: Text(
                'Pesan Tersimpan',
                style: TextStyle(
                  color: context.theme.indicatorColor,
                ),
              ),
            ),
            ListTile(
              onTap: () async {
                await context.navigator().push(PageRouteBuilder(
                  pageBuilder: (context, animation, secondaryAnimation) {
                    SettingsPageAppTelegramTemplate
                        settingsPageAppTelegramTemplate =
                        SettingsPageAppTelegramTemplate(
                      appTelegramTemplateData: widget.appTelegramTemplateData,
                    );
                    return settingsPageAppTelegramTemplate;
                  },
                ));
              },
              leading: const Icon(
                Icons.settings,
              ),
              title: Text(
                'Settings',
                style: TextStyle(
                  color: context.theme.indicatorColor,
                ),
              ),
            ),
            ListTile(
              onTap: () async {
                switch (
                    widget.appTelegramTemplateData.themeModeNotifier.value) {
                  case ThemeMode.dark:
                    setState(() {
                      widget.appTelegramTemplateData.themeModeNotifier.value =
                          ThemeMode.light;
                    });
                    break;
                  case ThemeMode.light:
                    setState(
                      () {
                        widget.appTelegramTemplateData.themeModeNotifier.value =
                            ThemeMode.dark;
                      },
                    );
                    break;
                  default:
                    setState(
                      () {
                        widget.appTelegramTemplateData.themeModeNotifier.value =
                            ThemeMode.light;
                      },
                    );
                    break;
                }
              },
              leading: Icon(
                () {
                  if (widget.appTelegramTemplateData.themeModeNotifier.value ==
                      ThemeMode.light) {
                    return Icons.light_mode;
                  }
                  if (widget.appTelegramTemplateData.themeModeNotifier.value ==
                      ThemeMode.dark) {
                    return Icons.dark_mode;
                  }
                  return Icons.auto_mode_sharp;
                }(),
              ),
              title: const Text(
                'Theme Mode',
                style: TextStyle(),
              ),
            ),
          ],
        ),
      ),
      body: SingleChildScrollView(
        child: ConstrainedBox(
          constraints: BoxConstraints(
            minWidth: context.width,
            minHeight: context.height,
          ),
          child: FutureBuilder<Map>(
            future: () async {
              if (is_in_main_screen == false) {
                return {"chat_ids": []};
              }
              Map res = await widget.appTelegramTemplateData.invoke(
                context: context,
                parameters: {
                  "@type": "getChats",
                  "limit": 500,
                },

                // isInvokeThrowOnError: false,
              );

              if (res["@type"] == "chats" && res["total_count"] is int) {
                int total_count = res["total_count"];
                if (total_count > 500) {
                  return await widget.appTelegramTemplateData.invoke(
                    context: context,
                    parameters: {
                      "@type": "getChats",
                      "limit": total_count,
                    },
                  );
                }
                return res;
              }

              return {};
            }.call(),
            builder: (context, snapshot) {
              if (snapshot.data is Map) {
                Map chats = snapshot.data ?? {};
                List<int> chat_ids = () {
                  try {
                    return (chats["chat_ids"] as List).cast<int>();
                  } catch (e) {}
                  return [];
                }.call().whereType<int>().toList();
                return ListView.builder(
                  physics: const NeverScrollableScrollPhysics(),
                  shrinkWrap: true,
                  itemCount: chat_ids.length,
                  itemBuilder: (context, index) {
                    return FutureBuilder<Map>(
                      future: () async {
                        if (is_in_main_screen == false) {
                          return {};
                        }

                        return widget
                            .appTelegramTemplateData.telegramClient.tdlib
                            .invoke(
                          "getChat",
                          parameters: {
                            "chat_id": chat_ids[index],
                          },
                          isInvokeThrowOnError: false,
                        );
                      }.call(),
                      builder: (context, snapshot) {
                        if (is_in_main_screen == false) {
                          return SizedBox(
                              height: 50,
                              width: context.width,
                              child: const Center(
                                child: CircularProgressIndicator(),
                              ));
                        }
                        if (snapshot.data is Map) {
                          Map chat = snapshot.data ?? {};

                          // chat.printPretty();
                          DecorationImage? image;

                          if (chat["photo"] is Map) {
                            Map photo = chat["photo"];
                            if (photo["minithumbnail"] is Map &&
                                photo["minithumbnail"]["data"] is String) {
                              image = DecorationImage(
                                fit: BoxFit.cover,
                                image: Image.memory(
                                  base64Decode(photo["minithumbnail"]["data"]),
                                ).image,
                              );
                            }
                          }

                          return ListTile(
                            onTap: () async {},
                            leading: Container(
                              height: 45,
                              width: 45,
                              decoration: BoxDecoration(
                                  color: Colors.red, image: image),
                            ),
                            title: Text(
                              chat["title"] ?? "",
                            ),
                          );
                        }
                        return SizedBox(
                          height: 50,
                          width: context.width,
                          child: const Center(
                            child: CircularProgressIndicator(),
                          ),
                        );
                      },
                    );
                  },
                );
              }
              return const Center(
                child: CircularProgressIndicator(),
              );
            },
          ),
        ),
      ),
      floatingActionButton: FloatingActionButton(
        onPressed: () async {
          await floatingAddAction(context: context);
          print("close action");
        },
        child: const Icon(Icons.add),
      ),
    );
  }

  Future<void> floatingAddAction({
    required BuildContext context,
  }) async {
    await showDialog(
      context: context,
      barrierDismissible: false,
      useSafeArea: false,
      useRootNavigator: false,
      builder: (context) {
        return ActionCreatePageAppTelegramTemplate(
            appTelegramTemplateData: widget.appTelegramTemplateData);
      },
    );
  }

  Future<void> searchChats({
    required BuildContext context,
  }) async {
    await showDialog(
      context: context,
      barrierDismissible: false,
      useSafeArea: false,
      useRootNavigator: false,
      builder: (context) {
        TextEditingController searchTextEditingController =
            TextEditingController();

        return StatefulBuilder(
          builder: (context, setStat) {
            print("slebew: ${is_in_main_screen}");
            return Scaffold(
              appBar: AppBar(
                backgroundColor: context.theme.dialogBackgroundColor,
                leading: MaterialButton(
                  minWidth: 0,
                  onPressed: () async {
                    if (context.navigator().canPop()) {
                      is_in_main_screen = true;
                      setState(() {});
                      context.navigator().pop();
                    }
                  },
                  child: const Icon(Icons.arrow_back),
                ),
                title: TextFormField(
                  cursorColor: context.theme.indicatorColor,
                  // color: context.theme.indicatorColor,
                  autovalidateMode: AutovalidateMode.onUserInteraction,
                  readOnly: false,
                  enabled: true,
                  // initialValue: languageDetailData.name,
                  controller: searchTextEditingController,
                  onChanged: (String value) async {},
                  style: TextStyle(
                    color: context.theme.indicatorColor,
                  ),
                  decoration: InputDecoration(
                    contentPadding: EdgeInsets.all(10.0),
                    hintText: "Search",
                    // suffixIcon: MaterialButton(
                    //   onPressed: () {
                    //     setStat(() {
                    //       searchTextEditingController.clear();
                    //       // languageCodeDetailDatas = languageCodeDetailData.entries.toList();
                    //     });
                    //   },
                    //   child: Icon(Icons.close),
                    // ),
                    labelStyle: TextStyle(
                      color: context.theme.indicatorColor,
                      fontSize: 14.0,
                      fontWeight: FontWeight.w400,
                    ),
                    hintStyle: TextStyle(
                      color: Colors.grey,
                      fontSize: 14.0,
                    ),
                    disabledBorder: OutlineInputBorder(
                      borderSide: BorderSide(
                        color: context.theme.indicatorColor,
                        width: 0,
                      ),
                      // borderRadius: BorderRadius.circular(10.0),
                    ),
                    enabledBorder: OutlineInputBorder(
                      borderSide: BorderSide(
                        color: context.theme.indicatorColor,
                        width: 0,
                      ),
                      // borderRadius: BorderRadius.circular(10.0),
                    ),
                    floatingLabelStyle: TextStyle(
                      color: context.theme.indicatorColor,
                      fontSize: 18.0,
                    ),
                    focusedErrorBorder: OutlineInputBorder(
                      borderSide: BorderSide(
                        color: context.theme.indicatorColor,
                        width: 0,
                      ),
                      // borderRadius: BorderRadius.circular(15.0),
                    ),
                    errorBorder: OutlineInputBorder(
                      borderSide: BorderSide(
                        color: context.theme.indicatorColor,
                        width: 0,
                      ),
                      // borderRadius: BorderRadius.circular(15.0),
                    ),
                    focusedBorder: OutlineInputBorder(
                      borderSide: BorderSide(
                        // color: Color.fromRGBO(0, 0, 0, 0),
                        color: context.theme.indicatorColor,
                        width: 0,
                      ),
                      // borderRadius: BorderRadius.circular(10.0),
                    ),
                    // focusedBorder: OutlineInputBorder(
                    //   borderSide: const BorderSide(
                    //     color: Color.fromARGB(255, 0, 0, 0),
                    //     width: 1.5,
                    //   ),
                    //   borderRadius: BorderRadius.circular(15.0),
                    // ),
                  ),
                ),
                actions: [
                  MaterialButton(
                    minWidth: 0,
                    onPressed: () async {
                      setStat(() {});
                    },
                    child: const RotatedBox(
                        quarterTurns: 2, child: Icon(Icons.arrow_back_ios_new)),
                  ),
                ],
              ),
              body: FutureBuilder<Map>(
                future: () async {
                  if (is_in_main_screen) {
                    return {};
                  }
                  if (searchTextEditingController.text.isNotEmpty) {
                    Map chats = await widget
                        .appTelegramTemplateData.telegramClient.tdlib
                        .invoke(
                      "searchPublicChats",
                      parameters: {
                        "query": searchTextEditingController.text,
                      },
                      isInvokeThrowOnError: false,
                    );

                    return chats;
                  }
                  return {};
                }.call(),
                builder: (context, snapshot) {
                  if (snapshot.data is Map && is_in_main_screen == false) {
                    Map chats = snapshot.data ?? {};
                    List<int> chat_ids = () {
                      try {
                        return (chats["chat_ids"] as List).cast<int>();
                      } catch (e) {}
                      return [];
                    }.call().whereType<int>().toList();
                    return ListView.builder(
                      physics: const NeverScrollableScrollPhysics(),
                      shrinkWrap: true,
                      itemCount: chat_ids.length,
                      itemBuilder: (context, index) {
                        return FutureBuilder<Map>(
                          future: () async {
                            if (is_in_main_screen) {
                              return {};
                            }

                            return widget
                                .appTelegramTemplateData.telegramClient.tdlib
                                .invoke(
                              "getChat",
                              parameters: {
                                "chat_id": chat_ids[index],
                              },
                              isInvokeThrowOnError: false,
                            );
                          }.call(),
                          builder: (context, snapshot) {
                            if (is_in_main_screen) {
                              return SizedBox(
                                height: 50,
                                width: context.width,
                                child: const Center(
                                  child: CircularProgressIndicator(),
                                ),
                              );
                            }
                            if (snapshot.data is Map) {
                              Map chat = snapshot.data ?? {};

                              DecorationImage? image;

                              if (chat["photo"] is Map) {
                                Map photo = chat["photo"];
                                if (photo["minithumbnail"] is Map &&
                                    photo["minithumbnail"]["data"] is String) {
                                  image = DecorationImage(
                                    fit: BoxFit.cover,
                                    image: Image.memory(
                                      base64Decode(
                                          photo["minithumbnail"]["data"]),
                                    ).image,
                                  );
                                }
                              }

                              return ListTile(
                                onTap: () async {},
                                leading: Container(
                                  height: 45,
                                  width: 45,
                                  decoration: BoxDecoration(
                                      color: Colors.red, image: image),
                                ),
                                title: Text(
                                  chat["title"] ?? "",
                                ),
                              );
                            }
                            return SizedBox(
                              height: 50,
                              width: context.width,
                              child: const Center(
                                child: CircularProgressIndicator(),
                              ),
                            );
                          },
                        );
                      },
                    );
                  }
                  if (snapshot.connectionState == ConnectionState.waiting) {
                    return const Center(
                      child: CircularProgressIndicator(),
                    );
                  }
                  return const SizedBox.shrink();
                },
              ),
            );
          },
        );
      },
    );
  }
}

class ActionCreatePageAppTelegramTemplate
    extends AppTelegramTemplateStatefulWidget {
  const ActionCreatePageAppTelegramTemplate(
      {super.key, required super.appTelegramTemplateData});

  @override
  State<ActionCreatePageAppTelegramTemplate> createState() =>
      _ActionCreatePageAppTelegramTemplateState();
}

class _ActionCreatePageAppTelegramTemplateState
    extends State<ActionCreatePageAppTelegramTemplate> {
  @override
  Widget build(BuildContext context) {
    return Scaffold(
      appBar: AppBar(
        backgroundColor: context.theme.dialogBackgroundColor,
        leading: MaterialButton(
          minWidth: 0,
          onPressed: () async {
            if (context.navigator().canPop()) {
              context.navigator().pop();
            }
          },
          child: const Icon(Icons.arrow_back),
        ),
        actions: [
          MaterialButton(
            minWidth: 0,
            onPressed: () async {},
            child: const RotatedBox(
                quarterTurns: 2, child: Icon(Icons.arrow_back_ios_new)),
          ),
        ],
      ),
      body: Column(
        children: [
          ListTile(
            onTap: () {},
            leading: const Icon(
              Icons.people,
            ),
            title: Text(
              'New Group',
              style: TextStyle(
                color: context.theme.indicatorColor,
              ),
            ),
          ),
          ListTile(
            onTap: () {},
            leading: const Icon(
              Icons.people,
            ),
            title: Text(
              'New Supergroup',
              style: TextStyle(
                color: context.theme.indicatorColor,
              ),
            ),
          ),
          ListTile(
            onTap: () {},
            leading: const Icon(
              Icons.speaker,
            ),
            title: Text(
              'New Channel',
              style: TextStyle(
                color: context.theme.indicatorColor,
              ),
            ),
          ),
          ListTile(
            onTap: () {},
            leading: const Icon(
              Icons.people,
            ),
            title: Text(
              'New Stories',
              style: TextStyle(
                color: context.theme.indicatorColor,
              ),
            ),
          ),
          Divider(),
        ],
      ),
    );
  }
}
