// ignore_for_file: avoid_print, unused_local_variable

import 'dart:io';

import 'package:app_telegram_template/language/settings_account.dart';
import 'package:app_telegram_template/page/settings/settings_setting_chat.dart';
import 'package:app_telegram_template/page/settings/settings_setting_device.dart';
import 'package:app_telegram_template/page/settings/settings_setting_notification_and_sound.dart';
import 'package:app_telegram_template/page/settings/settings_setting_privacy_and_security.dart';
import 'package:app_telegram_template/widget/app_telegram_template.dart';
import 'package:flutter/material.dart';

import 'package:flutter_hicons/flutter_hicons.dart';

import 'package:general_lib_flutter/general_lib_flutter.dart';
import 'package:shimmer/shimmer.dart';

class SettingsPageAppTelegramTemplate
    extends AppTelegramTemplateStatefulWidget {
  const SettingsPageAppTelegramTemplate({
    super.key,
    required super.appTelegramTemplateData,
  });

  @override
  State<SettingsPageAppTelegramTemplate> createState() =>
      _SettingsPageAppTelegramTemplateState();
}

class _SettingsPageAppTelegramTemplateState
    extends State<SettingsPageAppTelegramTemplate> {
  final GlobalKey bottomBarKey = GlobalKey();

  final GlobalKey globalKey = GlobalKey();

  final scaffoldKey = GlobalKey<ScaffoldState>();

  PageController pageController = PageController();

  Size getRedBoxSize(BuildContext context) {
    final box = context.findRenderObject() as RenderBox;
    return box.size;
  }

  @override
  void initState() {
    // TODO: implement initState
    super.initState();

    WidgetsBinding.instance.addPostFrameCallback((_) {
      setState(() {
        // redboxSize = getRedBoxSize(globalKey.currentContext!);
      });
    });
  }

  @override
  Widget build(BuildContext context) {
    // print(widget.getRedBoxSize()!.height);
    return Scaffold(
      extendBodyBehindAppBar: true,
      extendBody: true,
      appBar: () {
        return PreferredSize(
          preferredSize: Size(
            context.width,
            450,
          ), // here the desired height
          child: Container(
            key: globalKey,
            decoration: BoxDecoration(
              color: context.theme.dialogBackgroundColor.withOpacity(0.85),
              boxShadow: [
                BoxShadow(
                  color: context.theme.shadowColor.withAlpha(110),
                  spreadRadius: 1,
                  blurRadius: 7,
                  offset: const Offset(0, 3), // changes position of shadow
                ),
              ],
            ),
            child: Column(
              mainAxisSize: MainAxisSize.min,
              crossAxisAlignment: CrossAxisAlignment.start,
              children: [
                SizedBox(
                  height: context.mediaQueryData.padding.top,
                ),
                MaterialButton(
                  shape: RoundedRectangleBorder(
                    borderRadius: BorderRadius.circular(25.0),
                  ),
                  hoverColor: Colors.transparent,
                  splashColor: Colors.transparent,
                  highlightColor: Colors.transparent,
                  onPressed: () async {},
                  padding: const EdgeInsets.all(15),
                  child: Row(
                    mainAxisSize: MainAxisSize.max,
                    mainAxisAlignment: MainAxisAlignment.spaceBetween,
                    children: [
                      MaterialButton(
                        shape: RoundedRectangleBorder(
                          borderRadius: BorderRadius.circular(25.0),
                        ),
                        minWidth: 0,
                        onPressed: () async {
                          context.navigator().pop();
                        },
                        child: const Icon(Icons.arrow_back_ios_sharp),
                      ),
                      const Padding(
                        padding: EdgeInsets.all(10),
                        child: Text(
                          "Settings Page",
                          style: TextStyle(
                            fontSize: 16,
                            fontWeight: FontWeight.w600,
                          ),
                        ),
                      ),
                      Padding(
                        padding: const EdgeInsets.symmetric(vertical: 10),
                        child: Row(
                          // crossAxisAlignment: CrossAxisAlignment.end,
                          mainAxisAlignment: MainAxisAlignment.end,
                          children: [
                            Padding(
                              padding:
                                  const EdgeInsets.symmetric(horizontal: 5),
                              child: RotatedBox(
                                quarterTurns: 1,
                                child: InkWell(
                                  onTap: () async {},
                                  child: const Icon(Icons.qr_code),
                                ),
                              ),
                            ),
                            Padding(
                              padding:
                                  const EdgeInsets.symmetric(horizontal: 5),
                              child: RotatedBox(
                                quarterTurns: 1,
                                child: InkWell(
                                  onTap: () {},
                                  child: const Icon(Icons.search),
                                ),
                              ),
                            ),
                            Padding(
                              padding:
                                  const EdgeInsets.symmetric(horizontal: 5),
                              child: PopupMenuButton(
                                shape: const RoundedRectangleBorder(
                                    borderRadius: BorderRadius.all(
                                        Radius.circular(15.0))),
                                clipBehavior: Clip.antiAlias,
                                itemBuilder: (context) {
                                  return [
                                    const PopupMenuItem(
                                      child: Text("Add Account"),
                                    ),
                                    PopupMenuItem(
                                      child: const Text("Logout"),
                                      onTap: () async {
                                        // context.navigator().pushReplacement(
                                        //   MaterialPageRoute(
                                        //     builder: (context) {
                                        //       SignPage signPage = SignPage(appData: widget.appData);

                                        //       if (widget.appData.is_debug) {
                                        //         return AppDebug(
                                        //           themeMode: widget.appData.themeModeNotifier,
                                        //           child: signPage,
                                        //         );
                                        //       }
                                        //       return signPage;
                                        //     },
                                        //   ),
                                        // );
                                      },
                                    ),
                                  ];
                                },
                                child: const RotatedBox(
                                  quarterTurns: 1,
                                  child: Icon(Icons.more_horiz_sharp),
                                ),
                              ),
                            ),
                          ],
                        ),
                      ),
                    ],
                  ),
                ),
              ],
            ),
          ),
        );
      }(),
      body: body(),
    );
  }

  Widget body() {
    return SingleChildScrollView(
      physics: const AlwaysScrollableScrollPhysics(
        parent: BouncingScrollPhysics(),
      ),
      child: ConstrainedBox(
        constraints: BoxConstraints(
          minHeight: context.height,
          minWidth: context.width,
        ),
        child: Column(
          crossAxisAlignment: CrossAxisAlignment.start,
          children: [
            SizedBox.fromSize(
              size: () {
                try {
                  return getRedBoxSize(globalKey.currentContext!);
                } catch (e) {
                  return null;
                }
              }(),
            ),
            // Center(
            //   child: Padding(
            //     padding: const EdgeInsets.all(25),
            //     child: ProfilePicture(
            //       pathImage: "assets/icons/ai.png",
            //       width: 150,
            //       height: 150,
            //       borderRadius: const BorderRadius.all(Radius.circular(50)),
            //       onPressed: () async {},
            //     ),
            //   ),
            // ),
            //
            //
            Container(
              margin: const EdgeInsets.all(10),
              decoration: BoxDecoration(
                borderRadius: const BorderRadius.all(Radius.circular(20)),
                color: context.theme.dialogBackgroundColor.withOpacity(0.85),
                boxShadow: [
                  BoxShadow(
                    color: context.theme.shadowColor,

                    spreadRadius: 1,
                    blurRadius: 7,
                    offset: const Offset(0, 3), // changes position of shadow
                  ),
                ],
              ),
              clipBehavior: Clip.antiAliasWithSaveLayer,
              child: FutureBuilder(
                future: Future(() async {
                  return await widget.appTelegramTemplateData.invoke(
                    context: context,
                    parameters: {"@type": "getMe"},
                    isInvokeThrowOnError: false,
                  );
                }),
                builder: (context, snapshot) {
                  Map data = snapshot.data ?? {};
                  Column child = Column(
                    mainAxisSize: MainAxisSize.min,
                    children: [
                      Padding(
                        padding: const EdgeInsets.all(10),
                        child: Align(
                          alignment: Alignment.centerLeft,
                          child: Text(
                            widget.appTelegramTemplateData.language
                                .settings_account_title(),
                          ),
                        ),
                      ),
                      buttonSetting(
                        iconData: Hicons.profile_1_light_outline,
                        title: "ID",
                        subtitle: "${data["id"] ?? ""}",
                        onPressed: () {},
                      ),
                      buttonSetting(
                        iconData: Hicons.profile_1_light_outline,
                        subtitle:
                            "${data["first_name"] ?? ""} ${data["last_name"] ?? ""}"
                                .trim(),
                        title: widget.appTelegramTemplateData.language
                            .settings_account_nick_name(),
                        onPressed: () {},
                      ),
                      buttonSetting(
                        iconData: Hicons.user_tag_light_outline,
                        subtitle: "${data["username"] ?? ""}".trim(),
                        title: widget.appTelegramTemplateData.language
                            .settings_account_username(),
                        onPressed: () {},
                      ),
                      buttonSetting(
                        iconData: Hicons.call_light_outline,
                        // title: "xxxxxx",
                        subtitle: "${data["phone_number"] ?? ""}".trim(),
                        title: widget.appTelegramTemplateData.language
                            .settings_account_phone_number(),
                        onPressed: () {},
                      ),
                      buttonSetting(
                        iconData: Hicons.location_cross_light_outline,
                        title: widget.appTelegramTemplateData.language
                            .settings_account_bio(),
                        onPressed: () {},
                      ),
                    ],
                  );

                  if (snapshot.hasData) {
                    return child;
                  }

                  return Shimmer.fromColors(
                      baseColor: Color.fromARGB(255, 71, 71, 71),
                      highlightColor: context.theme.indicatorColor,
                      child: child);
                },
              ),
            ),
            Container(
              margin: const EdgeInsets.all(10),
              decoration: BoxDecoration(
                borderRadius: const BorderRadius.all(Radius.circular(20)),
                color: context.theme.dialogBackgroundColor.withOpacity(0.85),
                boxShadow: [
                  BoxShadow(
                    color: context.theme.shadowColor,
                    spreadRadius: 1,
                    blurRadius: 7,
                    offset: const Offset(0, 3), // changes position of shadow
                  ),
                ],
              ),
              clipBehavior: Clip.antiAliasWithSaveLayer,
              child: Column(
                mainAxisSize: MainAxisSize.min,
                children: [
                  const Padding(
                    padding: EdgeInsets.all(10),
                    child: Align(
                      alignment: Alignment.centerLeft,
                      child: Text(
                        "Pengaturan",
                      ),
                    ),
                  ),
                  buttonSetting(
                    iconData: Hicons.message_12_light_outline,
                    title: "Pengaturan Obrolan",
                    onPressed: () async {
                      await context.navigator().push(PageRouteBuilder(
                        pageBuilder: (context, animation, secondaryAnimation) {
                          SettingsChatPageAppTelegramTemplate
                              settingsChatPageAppTelegramTemplate =
                              SettingsChatPageAppTelegramTemplate(
                            appTelegramTemplateData:
                                widget.appTelegramTemplateData,
                          );
                          return settingsChatPageAppTelegramTemplate;
                        },
                      ));
                    },
                  ),
                  buttonSetting(
                    iconData: Hicons.security_safe_light_outline,
                    title: "Pivasi dan keamanan",
                    onPressed: () async {
                      await context.navigator().push(PageRouteBuilder(
                        pageBuilder: (context, animation, secondaryAnimation) {
                          SettingsSettingPrivacyAndSecurityPageAppTelegramTemplate
                              settingPrivacyAndSecurityPageAppTelegramTemplate =
                              SettingsSettingPrivacyAndSecurityPageAppTelegramTemplate(
                            appTelegramTemplateData:
                                widget.appTelegramTemplateData,
                          );
                          return settingPrivacyAndSecurityPageAppTelegramTemplate;
                        },
                      ));
                    },
                  ),
                  buttonSetting(
                    iconData: Hicons.notification_4_light_outline,
                    title: "Notifikasi dan Suara",
                    onPressed: () async {
                      await context.navigator().push(PageRouteBuilder(
                        pageBuilder: (context, animation, secondaryAnimation) {
                          SettingsSettingNotificationAndSoundPageAppTelegramTemplate
                              settingsSettingNotificationAndSoundPageAppTelegramTemplate =
                              SettingsSettingNotificationAndSoundPageAppTelegramTemplate(
                            appTelegramTemplateData:
                                widget.appTelegramTemplateData,
                          );
                          return settingsSettingNotificationAndSoundPageAppTelegramTemplate;
                        },
                      ));
                    },
                  ),
                  buttonSetting(
                    iconData: Hicons.activity_3_light_outline,
                    title: "Data Dan Penyimpanan",
                    onPressed: () async {
                      await context.navigator().push(PageRouteBuilder(
                        pageBuilder: (context, animation, secondaryAnimation) {
                          SettingsSettingNotificationAndSoundPageAppTelegramTemplate
                              settingsSettingNotificationAndSoundPageAppTelegramTemplate =
                              SettingsSettingNotificationAndSoundPageAppTelegramTemplate(
                            appTelegramTemplateData:
                                widget.appTelegramTemplateData,
                          );
                          return settingsSettingNotificationAndSoundPageAppTelegramTemplate;
                        },
                      ));
                    },
                  ),
                  buttonSetting(
                    iconData: Hicons.shield_cross_light_outline,
                    title: "Penghematan Daya",
                    onPressed: () async {
                      await context.navigator().push(PageRouteBuilder(
                        pageBuilder: (context, animation, secondaryAnimation) {
                          SettingsSettingNotificationAndSoundPageAppTelegramTemplate
                              settingsSettingNotificationAndSoundPageAppTelegramTemplate =
                              SettingsSettingNotificationAndSoundPageAppTelegramTemplate(
                            appTelegramTemplateData:
                                widget.appTelegramTemplateData,
                          );
                          return settingsSettingNotificationAndSoundPageAppTelegramTemplate;
                        },
                      ));
                    },
                  ),
                  buttonSetting(
                    iconData: Hicons.location_cross_light_outline,
                    title: "Folder Obrolan",
                    onPressed: () async {
                      await context.navigator().push(PageRouteBuilder(
                        pageBuilder: (context, animation, secondaryAnimation) {
                          SettingsSettingNotificationAndSoundPageAppTelegramTemplate
                              settingsSettingNotificationAndSoundPageAppTelegramTemplate =
                              SettingsSettingNotificationAndSoundPageAppTelegramTemplate(
                            appTelegramTemplateData:
                                widget.appTelegramTemplateData,
                          );
                          return settingsSettingNotificationAndSoundPageAppTelegramTemplate;
                        },
                      ));
                    },
                  ),
                  buttonSetting(
                    iconData: Hicons.location_cross_light_outline,
                    title: "Perangkat",
                    onPressed: () async {
                      await context.navigator().push(PageRouteBuilder(
                        pageBuilder: (context, animation, secondaryAnimation) {
                          SettingsSettingDevicePageAppTelegramTemplate
                              settingDevicePageAppTelegramTemplate =
                              SettingsSettingDevicePageAppTelegramTemplate(
                            appTelegramTemplateData:
                                widget.appTelegramTemplateData,
                          );
                          return settingDevicePageAppTelegramTemplate;
                        },
                      ));
                    },
                  ),
                  buttonSetting(
                    iconData: Hicons.location_cross_light_outline,
                    title: "Bahasa",
                    onPressed: () async {
                      await context.navigator().push(PageRouteBuilder(
                        pageBuilder: (context, animation, secondaryAnimation) {
                          SettingsSettingNotificationAndSoundPageAppTelegramTemplate
                              settingsSettingNotificationAndSoundPageAppTelegramTemplate =
                              SettingsSettingNotificationAndSoundPageAppTelegramTemplate(
                            appTelegramTemplateData:
                                widget.appTelegramTemplateData,
                          );
                          return settingsSettingNotificationAndSoundPageAppTelegramTemplate;
                        },
                      ));
                    },
                  ),
                ],
              ),
            ),
            Container(
              margin: const EdgeInsets.all(10),
              decoration: BoxDecoration(
                borderRadius: const BorderRadius.all(Radius.circular(20)),
                color: context.theme.dialogBackgroundColor.withOpacity(0.85),
                boxShadow: [
                  BoxShadow(
                    color: context.theme.shadowColor,
                    spreadRadius: 1,
                    blurRadius: 7,
                    offset: const Offset(0, 3), // changes position of shadow
                  ),
                ],
              ),
              clipBehavior: Clip.antiAliasWithSaveLayer,
              child: Column(
                mainAxisSize: MainAxisSize.min,
                children: [
                  const Padding(
                    padding: EdgeInsets.all(10),
                    child: Align(
                      alignment: Alignment.centerLeft,
                      child: Text(
                        "App",
                      ),
                    ),
                  ),
                  buttonSetting(
                    iconData: Hicons.discovery_1_light_outline,
                    title: "Author",
                    onPressed: () {},
                  ),
                  buttonSetting(
                    iconData: Hicons.cup_light_outline,
                    title: "Donate",
                    onPressed: () {},
                  ),
                  buttonSetting(
                    iconData: Hicons.security_safe_light_outline,
                    title: "LICENSE",
                    onPressed: () async {
                      await showDialog(
                        context: context,
                        barrierDismissible: false,
                        useSafeArea: false,
                        useRootNavigator: false,
                        builder: (context) {
                          return const LicensePage(
                            applicationName: "Telegram App By AZKA DEVELOPER",
                          );
                        },
                      );
                    },
                  ),
                ],
              ),
            ),
            Container(
              margin: const EdgeInsets.all(10),
              decoration: BoxDecoration(
                borderRadius: const BorderRadius.all(Radius.circular(20)),
                color: context.theme.dialogBackgroundColor.withOpacity(0.85),
                boxShadow: [
                  BoxShadow(
                    color: context.theme.shadowColor,
                    spreadRadius: 1,
                    blurRadius: 7,
                    offset: const Offset(0, 3), // changes position of shadow
                  ),
                ],
              ),
              clipBehavior: Clip.antiAliasWithSaveLayer,
              child: Column(
                mainAxisSize: MainAxisSize.min,
                children: [
                  buttonSetting(
                    iconData: Hicons.verified_light_outline,
                    title: "Telegram Premium",
                    onPressed: () {},
                  ),
                ],
              ),
            ),
            Container(
              margin: const EdgeInsets.all(10),
              decoration: BoxDecoration(
                borderRadius: const BorderRadius.all(Radius.circular(20)),
                color: context.theme.dialogBackgroundColor.withOpacity(0.85),
                boxShadow: [
                  BoxShadow(
                    color: context.theme.shadowColor,
                    spreadRadius: 1,
                    blurRadius: 7,
                    offset: const Offset(0, 3), // changes position of shadow
                  ),
                ],
              ),
              clipBehavior: Clip.antiAliasWithSaveLayer,
              child: Column(
                mainAxisSize: MainAxisSize.min,
                children: [
                  const Padding(
                    padding: EdgeInsets.all(10),
                    child: Align(
                      alignment: Alignment.centerLeft,
                      child: Text(
                        "Bantuan",
                      ),
                    ),
                  ),
                  buttonSetting(
                    iconData: Hicons.faq_circle_bold,
                    title: "Kirim Pertanyaan",
                    onPressed: () {},
                  ),
                  buttonSetting(
                    iconData: Hicons.faq_circle_bold,
                    title: "Pertanyaan Umum",
                    onPressed: () {},
                  ),
                  buttonSetting(
                    iconData: Hicons.security_safe_light_outline,
                    title: "Kebijakan Privasi",
                    onPressed: () {},
                  ),
                ],
              ),
            ),

            ListTile(
              onTap: () {},
              onLongPress: () {},
              title: Text(
                'Telegram untuk ${Platform.operatingSystem} ',
                style: const TextStyle(
                  color: Colors.grey,
                ),
                textAlign: TextAlign.center,
              ),
            ),
          ],
        ),
      ),
    );
  }

  Widget buttonSetting(
      {required IconData iconData,
      required String title,
      String? subtitle,
      void Function()? onPressed}) {
    return MaterialButton(
      onPressed: onPressed,
      child: ListTile(
        leading: Icon(iconData),
        title: Text(title),
        subtitle: (subtitle != null) ? Text(subtitle) : null,
      ),
    );
  }
}
